//+------------------------------------------------------------------+
//|                                   DiNapoli Detrend Predictor.mq4 |
//|                    Copyright � 2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright � 2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 3
#property  indicator_color1  Green
#property  indicator_width1  1
#property  indicator_color2  Red
#property  indicator_width2  1
#property  indicator_color3  Red
#property  indicator_width3  1

//---- indicator parameters
extern int CountBars=1001;
extern int period=7;
extern int numberofhighs=10;
extern int numberoflows=10;
extern bool showonebarahead=true;
//pricemodes: 0=PRICE_CLOSE, 1=PRICE_OPEN,2=PRICE_HIGH,3=PRICE_LOW;

//---- indicator buffers

double     overbought[];
double     oversold[];
double     zeroline[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings

   SetIndexStyle(0,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(0,period);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(1,period);
   SetIndexStyle(2,DRAW_LINE,STYLE_DOT);
   SetIndexDrawBegin(2,period);

//---- indicator buffers mapping
   SetIndexBuffer(0,overbought);  
   SetIndexBuffer(1,oversold);
   SetIndexBuffer(2,zeroline);
      
   IndicatorShortName("Detrend");
   SetIndexLabel(0,"OB");
   SetIndexLabel(1,"OS");
   SetIndexLabel(2,"Zero");

//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
  int limit,i;

//----//----//----//----//----//----//----//----
//Overbought/Oversold Level Calculation
 
   int b=0;   
   double max_[],min_[];
   int maxi=ArrayResize( max_, numberofhighs);
   int mini=ArrayResize( min_, numberoflows);
   int posiofmax_[],posiofmin_[];
   int posiofmaxi=ArrayResize( posiofmax_, numberofhighs);
   int posiofmini=ArrayResize( posiofmin_, numberoflows);


   for(i=0;i<numberofhighs;i++)
   {
   max_[i]=0.0; 
   posiofmax_[i]=0;
   }
   for(i=0;i<numberoflows;i++)
   {
   min_[i]=0.0;
   posiofmin_[i]=0;
   }
   double valueshighs_[],valueslows_[];
   int bi=ArrayResize( valueshighs_, CountBars); 
   int bix=ArrayResize( valueslows_, CountBars);
   
   for(i=0;i<CountBars;i++)
   {
   valueshighs_[i]=0.0;  
   valueslows_[i]=0.0;
   }
   for(i=0;i<CountBars;i++)
   {
    valueshighs_[i]=Close[i]-iMA(NULL,0,period,MODE_SMA,0,0,i);
    valueslows_[i]=Close[i]-iMA(NULL,0,period,MODE_SMA,0,0,i);
   }
   for(i=0;i<numberofhighs;i++)
   {
   posiofmax_[i]=ArrayMaximum(valueshighs_,WHOLE_ARRAY,0);
   max_[i]=valueshighs_[posiofmax_[i]];
   valueshighs_[posiofmax_[i]]=0.0;
   }
   double averagehigh=iMAOnArray(max_,0,numberofhighs,0,0,0);

   for(i=0;i<numberoflows;i++)
   {
   posiofmin_[i]=ArrayMinimum(valueslows_,WHOLE_ARRAY,0);
   min_[i]=valueslows_[posiofmin_[i]];
   valueslows_[posiofmin_[i]]=0.0;
   }
 
   double averagemin=iMAOnArray(min_,0,numberoflows,0,0,0);
   double minib;
   minib=averagemin;
   
   for(i=0; i<CountBars; i++)
   {  

      oversold[i]=averagemin+iMA(NULL,0,period,0,MODE_SMA,0,i);  
      overbought[i]=averagehigh+iMA(NULL,0,period,0,MODE_SMA,0,i);
      zeroline[i]=0.0+iMA(NULL,0,period,0,MODE_SMA,0,i);

   }
   double ospredict,obpredict,zpredict;
   if(showonebarahead==true)
   {
//oversoldpredict
   ospredict=((oversold[0]-averagemin)*period-Close[period]+Close[0])/period+averagemin;  
   Comment(DoubleToStr(ospredict,4));
   datetime futureBarTime = Time[0]+Period()*60; 
 
   ObjectCreate("ospredict",OBJ_TREND,0,Time[0],oversold[0],futureBarTime,ospredict);
   ObjectSet("ospredict",OBJPROP_COLOR,Gold);
   ObjectSet("ospredict",OBJPROP_RAY,false);
   ObjectSet("ospredict",OBJPROP_STYLE,STYLE_DASH);
   double predict1=ObjectGet("ospredict",OBJPROP_PRICE2);
      
   if(predict1<ospredict||predict1>ospredict)
   {
   ObjectDelete("ospredict");
      
   ObjectCreate("ospredict",OBJ_TREND,0,Time[0],oversold[0],futureBarTime,ospredict);
   ObjectSet("ospredict",OBJPROP_COLOR,Gold);
   ObjectSet("ospredict",OBJPROP_RAY,false);
   ObjectSet("ospredict",OBJPROP_STYLE,STYLE_DASH);
   predict1=ObjectGet("ospredict",OBJPROP_PRICE1);}

//overboughtpredict
   obpredict=((overbought[0]-averagehigh)*period-Close[period]+Close[0])/period+averagehigh;  

   ObjectCreate("obpredict",OBJ_TREND,0,Time[0],oversold[0],futureBarTime,ospredict);
   ObjectSet("obpredict",OBJPROP_COLOR,Gold);
   ObjectSet("obpredict",OBJPROP_RAY,false);
   ObjectSet("obpredict",OBJPROP_STYLE,STYLE_DASH);
   double predict2=ObjectGet("obpredict",OBJPROP_PRICE2);
      
   if(predict2<obpredict||predict2>obpredict)
   {
   ObjectDelete("obpredict");
      
   ObjectCreate("obpredict",OBJ_TREND,0,Time[0],overbought[0],futureBarTime,obpredict);
   ObjectSet("obpredict",OBJPROP_COLOR,Gold);
   ObjectSet("obpredict",OBJPROP_RAY,false);
   ObjectSet("obpredict",OBJPROP_STYLE,STYLE_DASH);
   predict2=ObjectGet("obpredict",OBJPROP_PRICE1);}

//zerolinepredict
   zpredict=((zeroline[0])*period-Close[period]+Close[0])/period;  

   ObjectCreate("zpredict",OBJ_TREND,0,Time[0],zeroline[0],futureBarTime,zpredict);
   ObjectSet("zpredict",OBJPROP_COLOR,Gold);
   ObjectSet("zpredict",OBJPROP_RAY,false);
   ObjectSet("zpredict",OBJPROP_STYLE,STYLE_DASH);
   double predict3=ObjectGet("zpredict",OBJPROP_PRICE2);
      
   if(predict3<zpredict||predict3>zpredict)
   {
   ObjectDelete("zpredict");
      
   ObjectCreate("zpredict",OBJ_TREND,0,Time[0],zeroline[0],futureBarTime,zpredict);
   ObjectSet("zpredict",OBJPROP_COLOR,Gold);
   ObjectSet("zpredict",OBJPROP_RAY,false);
   ObjectSet("zpredict",OBJPROP_STYLE,STYLE_DASH);
   predict3=ObjectGet("zpredict",OBJPROP_PRICE1);}

   }
   else
   {ObjectDelete("zpredict");
   ObjectDelete("obpredict");
   ObjectDelete("ospredict");
   }
   return(0);
 
  }
//+------------------------------------------------------------------+